#include "exdispid.h"
#include "exdisp.h"
#include <atlbase.h>
extern CComModule _Module;
#include <atlcom.h>


EXTERN_C const IID IID_IIECM = {0xca370040,0xe737,0x11d9,{0x8c,0xd6,0x08,0x00,0x20,0x0c,0x9a,0x66}};
EXTERN_C const IID LIBID_IECMLib = {0xca370041,0xe737,0x11d9,{0x8c,0xd6,0x08,0x00,0x20,0x0c,0x9a,0x66}};
EXTERN_C const CLSID CLSID_IECMObj = {0xca370042,0xe737,0x11d9,{0x8c,0xd6,0x08,0x00,0x20,0x0c,0x9a,0x66}};

MIDL_INTERFACE("ca370040-e737-11d9-8cd6-0800200c9a66")

IIECMObj : public IDispatch {};


class ATL_NO_VTABLE CIECMObj : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CIECMObj, &CLSID_IECMObj>,
	public IObjectWithSiteImpl<CIECMObj>,
	public IDispatchImpl<IIECMObj, &IID_IIECM, &LIBID_IECMLib>
{
public:

   DECLARE_NO_REGISTRY()
   DECLARE_NOT_AGGREGATABLE(CIECMObj)

   BEGIN_COM_MAP(CIECMObj)
	COM_INTERFACE_ENTRY(IIECMObj)
	COM_INTERFACE_ENTRY(IDispatch)
   	COM_INTERFACE_ENTRY_IMPL(IObjectWithSite)
   END_COM_MAP()

   STDMETHOD(Invoke)(DISPID dispidMember,REFIID riid, LCID lcid, WORD wFlags,DISPPARAMS * pdispparams, VARIANT * pvarResult,EXCEPINFO * pexcepinfo, UINT * puArgErr);
   STDMETHOD(SetSite)(IUnknown *pUnkSite);

private:
   DWORD m_dwCookie;
   CComQIPtr<IWebBrowser2, &IID_IWebBrowser2> m_spWebBrowser2;
   enum ConnectType {Advise, Unadvise};
   BOOL ManageConnection(enum ConnectType eConnectType);
};


CComModule _Module;

BEGIN_OBJECT_MAP(ObjectMap)
	OBJECT_ENTRY(CLSID_IECMObj, CIECMObj)
END_OBJECT_MAP()


STDAPI DllMain(HINSTANCE hInstance, DWORD dwReason, LPVOID lpReserved)
{
	if (dwReason == DLL_PROCESS_ATTACH)
	{
		_Module.Init(ObjectMap, hInstance);
		DisableThreadLibraryCalls(hInstance);
	}
	else if (dwReason == DLL_PROCESS_DETACH)
		_Module.Term();
	return TRUE;
}
STDAPI DllCanUnloadNow(void) { return (_Module.GetLockCount()==0) ? S_OK : S_FALSE; }
STDAPI DllGetClassObject(REFCLSID rclsid, REFIID riid, LPVOID* ppv){ return _Module.GetClassObject(rclsid, riid, ppv); }
STDAPI DllRegisterServer(void) { return _Module.RegisterServer(TRUE); }
STDAPI DllUnregisterServer(void)
{
	_Module.UnregisterServer();
	return S_OK;
}




BOOL CIECMObj::ManageConnection(enum ConnectType eConnectType)
{
   if (!m_spWebBrowser2) return S_OK;

   HRESULT hr;

   CComQIPtr<IConnectionPointContainer,&IID_IConnectionPointContainer> spCPContainer(m_spWebBrowser2);

   if (spCPContainer != NULL)
   {
      CComPtr<IConnectionPoint> spConnectionPoint;

      hr = spCPContainer->FindConnectionPoint(DIID_DWebBrowserEvents2, &spConnectionPoint);
      if (SUCCEEDED(hr))
      {
         if (eConnectType == Advise) hr = spConnectionPoint->Advise((IDispatch*)this, &m_dwCookie);
         else hr = spConnectionPoint->Unadvise(m_dwCookie);
      }
   }

   return (SUCCEEDED(hr));
}


STDMETHODIMP CIECMObj::SetSite(IUnknown *pUnkSite)
{

   if (pUnkSite)
   {
      m_spWebBrowser2 = pUnkSite;
      if (m_spWebBrowser2) ManageConnection(Advise);
   }

   return S_OK;
}


STDMETHODIMP CIECMObj::Invoke(DISPID dispidMember, REFIID riid, LCID lcid, WORD wFlags,DISPPARAMS* pDispParams, VARIANT* pvarResult,EXCEPINFO*  pExcepInfo,  UINT* puArgErr) {

  DWORD UrlSize;
  char UrlString[2084];


   if (!pDispParams) return E_INVALIDARG;

   switch (dispidMember)
   {

      case DISPID_BEFORENAVIGATE2:

         if (pDispParams->cArgs >= 5 && pDispParams->rgvarg[5].vt == (VT_BYREF|VT_VARIANT))
         {
            CComVariant varURL(*pDispParams->rgvarg[5].pvarVal);

            if (!(UrlSize = WideCharToMultiByte(CP_ACP, 0, varURL.bstrVal, -1, UrlString, 2084, NULL, NULL))) break;

	    MessageBox(NULL,UrlString,NULL,NULL);

         }
         else break;

      case DISPID_STATUSTEXTCHANGE:

         LPOLESTR lpStatusText;

         m_spWebBrowser2->get_StatusText(&lpStatusText);
         break;

      case DISPID_QUIT:

         ManageConnection(Unadvise);
         break;

      default:

         break;
   }

   return S_OK;
}